#include "list.h"

// ũ Ʈ .
// fnDelete :   Ž ȣ Լ ּ
// deleteData : true 带   ͵ Ѵ.
List::List(FN_DELETE fnDelete, bool deleteData)
{
	// ڸ Ѵ.
	this->fnDel = fnDelete;
	this->deleteData = deleteData;

	//  带  ʱȭѴ.
	head = new Node;
	head->prev = head;
	head->next = head;
	head->data = 0;
}

// ũ Ʈ Ҹ
List::~List()
{
	//  带 Ѵ.
	RemoveAll();

	//  带 Ѵ.
	delete head;
	head = 0;
}

// Ʈ  带 Ѵ. 
// Ʈ   ͵ Ѵ.
void List::RemoveAll()
{
	//     .
	// ( ̷ ϸ RemoveAll() Լ ȣ Ŀ
	// List ü ٽ   ִ)
	Node* current = head->next;

	while(current != head)
	{
		//  带  ̹Ƿ
		//  带 صд.
		Node* next = current->next;

		//   ͸ Ѵ.
		if (deleteData)
		{
			if (fnDel)
				(*fnDel)( current->data );
			else
				delete current->data;
		}

		//  带 Ѵ.
		delete current;

		// current  带 Ű Ѵ.
		current = next;
	}

	//  带 ʱȭѴ.
	head->next = head;
	head->prev = head;
}

// ù° 带 Ѵ.
// ȯ : Ʈ ù° 
Node* List::GetHead() const
{
	//  带 ȯѴ.
	return head;
}

//  带 Ѵ.
// ȯ : Ʈ  
Node* List::GetTail() const
{
	//    带 ȯѴ.
	// (  ڱ ڽ  ִ.)
	return head->prev;
}

// ο 带 ߰Ѵ.
// node :   ڿ  尡 ߰ȴ.
// data :   Ÿ
void List::InsertNodeAfter(Node* node, void* data)
{
	// ԵǷ  ,  带 س
	// б  ҽ ڵ带   ִ.
	Node* before = node;
	Node* after = node->next;

	//  带  ʱȭѴ.
	Node* newNode = new Node;
	newNode->data = data;
	newNode->next = after;
	newNode->prev = before;

	// node ڿ ִ 尡  带 Ű .
	after->prev = newNode;

	// Ű node  带 Ű .
	before->next = newNode;
}

// 带 Ѵ.
// node :  
void List::RemoveNode(Node* node)
{
	// node ,  带 س
	// б  ҽ ڵ带   ִ.
	Node* before = node->prev;
	Node* after = node->next;

	// node    带 ش.
	before->next = after;
	after->prev = before;

	//   ͸ Ѵ.
	if (deleteData)
	{
		if (fnDel)
			(*fnDel)( node->data );
		else
			delete node->data;
	}

	//  带 Ѵ.
	delete node;
}

//   带 ȯѴ.
// ȯ :  
Node* Node::GetNext() const
{
	return next;
}

//   带 ȯѴ.
// ȯ :  
Node* Node::GetPrev() const
{
	return prev;
}

// 忡  ͸ ȯѴ.
// ȯ :  Ÿ
void* Node::GetData() const
{
	return data;
}















